/*---------------------------------------------------------------------------**
**
**
** File: CYOA_LIB
**
** Author: Mark J. Musante
**
** Edit Lastochkin A.P
** Revision History:
**
**  2016-Jan-17 To russian languge
**
**	1998-Feb-09	Added 'restart' command.
**
**	1998-Jan-25	Added 'save' and 'restore' commands.
**
**	1998-Jan-22	Added 'undo' command.
**
**	1998-Jan-20	Initial version.
**
**
**---------------------------------------------------------------------------*/

//
// These definitions are required by the compiler, but are not
// used in this game.
//
takeVerb: object;
strObj: object;
numObj: object;
againVerb: object;
pardon: object;


// "Me" is used by the runtime to determine the left-hand side
// of the status line. Whatever is in 'Me.location.statusLine' 
// appears up there.
Me: object
	roomCheck( v ) = {
		return true;
	}
;

//
// Some global definitions.
//
global: object
	// ary is used by the choiceVerb class. Don't change it without
	// changing choiceVerb.action() as well
	ary = [ &choice_1, &choice_2, &choice_3,
	        &choice_4, &choice_5, &choice_6,
		&choice_7, &choice_8, &choice_9 ]
	
	// change death_msg before calling die(); if you want some
	// other message than 'You have died'
	death_msg = ''

	// if you want to change the propmt, change this
	prompt = '>'

	// this is the value that gets passed to initRestart when the user
	// requests a restart
	initRestartParam = 0


	// this is set to true in the default initRestart function
	restarting = nil
;

Place: object
	statusLine = ""
	desc = "*   *"
	choices = "\t*   *"
	choice_1 = nil
	choice_2 = nil
	choice_3 = nil
	choice_4 = nil
	choice_5 = nil
	choice_6 = nil
	choice_7 = nil
	choice_8 = nil
	choice_9 = nil
;

/* 'modify' this object in your source code.
**
** Sample:
**	modify intro
**		desc = "Here's a really cool introduction to my game. "
**	;
*/
intro: object
	desc = "(*)   'intro'    'desc'. "
;

/* 'modify' this object in your source code
**
** Sample:
**	modify version
**		desc = "The Cool Game, Serial Number 050123, Release 6. ";
**	;
*/
version: object
	desc = "    ,    TADS (the Text Adventure Development System)     CYOA_LIB
		Mark J.\ Musante,  .. "
;

/* 'modify' this object in your source code. This is the message that is
** displayed after the user decides to quit.
*/
endgame: object
	desc = "  !\b"
;

//  advr.t

//     
loweru: function(oldstr)
{
	local i,ret,ret1,tstr=oldstr,str='';
	local alph='';
	local ALPH='Ũ';
	
	if (oldstr=nil) return nil;
	ret := reSearch('[Ũ]',oldstr);
	if (ret=nil) return oldstr;
	 while (ret!=nil) 
	 {
	  ret1:=reSearch(substr(tstr,ret[1],1),ALPH);
	  if (ret[1]=1) str+=substr(alph,ret1[1],1);
	   else str:=str+substr(tstr,1,ret[1]-1)+substr(alph,ret1[1],1);
	  tstr:=substr(tstr,ret[1]+1,length(tstr)-ret[1]);
	  ret := reSearch('[Ũ]',tstr);
	 }
	if (length(tstr)>0) str:=str+tstr;
	return str;
}
;

//   ""  ""
dezyo: function(str)
{
  local ret;
  if (str!='') 
   {
	ret := reSearch('', str);
	while (ret != nil)
	{
	 if (ret[1]!=1) str:=substr(str,1,ret[1]-1)+''+substr(str,ret[1]+ret[2],length(str));
	 else str:=''+substr(str,2,length(str));
	 ret := reSearch('', str);
	} 
   }
   return str;
}
;

die: function
{
	local response;

	"\b\t* * *  <<global.death_msg>>. * * *\b";

	while (true)
    {
        "\n,  (), (), ()  ()  : >";
        response := upper(input());
        response := loweru(response);
        if ( (response='restore') or (response='') or (response='') )
        {
			response := askfile( '  ' );
			if ( response = nil )
				" . ";
			else if ( restore( response ) )
				" . ";
			else
				return;
		} else if ( (response='restart') or (response='') or (response='') ) {
			restart();
			return;
		} else if ( (response='undo') or (response='') or (response='') ) {
			if ( undo() ) {
				"(  )\b\t";
				Me.location.desc;
				return;
			} else {
				"   . ";
			}
		} else {
			endgame.desc;
			quit();
		}
	}
}

//
// Here's where we give some basic advice.
//
parseError: function( err, str )
{
	if ( err = 2 )
		return '   .      \'\'.';
	else
		return nil;
}

//
// This function allows us to convert the command line into a word
// that the TADS parser will allow us to handle.
//
preparse: function( str )
{
	local foo;

	if ( str = '' ) {
		"? ";
		return nil;
	}

	foo := cvtnum( str );
	switch( foo ) {
	case 1: return 'one';
	case 2: return 'two';
	case 3: return 'three';
	case 4: return 'four';
	case 5: return 'five';
	case 6: return 'six';
	case 7: return 'seven';
	case 8: return 'eight';
	case 9: return 'nine';
	default:
		if ( foo < 0 || foo > 9 || str = '0' ) {
			",    . ";
			return nil;
		}
		return true;
	}
}

//
// only allow one entry per command line
//
preparseCmd: function( list )
{
	local foo := [];

	if ( length( list ) = 1 )
		return true;
	else {
		foo += list[ 1 ];
		return foo;
	}
}

//
// This is the startup code
//
init: function
{
	"\b\b";
	intro.desc;
	"\b";
	version.desc;
	"\b\t";

	Me.location := startplace;

	Me.location.desc;
}

//
// Here's where we display the choice list & give the player the prompt
//
commandPrompt: function( type )
{
	if ( type = 0 || type = 1 ) {
		"\b    ?\b";
		Me.location.choices;
		"\b";
		say( global.prompt );
	} else {
		">";
	}
}

//
// Basic choices.  Numbered 1 through 9.
//
choiceVerb: object
	num = 0
	action( actor ) = {
		local newloc;
		
		if ( self.num = 0 ) {
			" :   .\n";
			abort;
		}

		if ( self.num < 1 || self.num > 9 ) {
			" :     .\b";
			abort;
		}

		if ( proptype( Me.location, global.ary[ self.num ] ) = 5 ) {
			",    . ";
			abort;
		}

		newloc := Me.location.( global.ary[ self.num ] );

		if ( newloc != nil ) {
			Me.location := newloc;
			"\b\t";
			Me.location.desc;
		}
	}
;

oneVerb: choiceVerb
	verb = 'one'
	num = 1
;

twoVerb: choiceVerb
	verb = 'two'
	num = 2
;

threeVerb: choiceVerb
	verb = 'three'
	num = 3
;

fourVerb: choiceVerb
	verb = 'four'
	num = 4
;

fiveVerb: choiceVerb
	verb = 'five'
	num = 5
;

sixVerb: choiceVerb
	verb = 'six'
	num = 6
;

sevenVerb: choiceVerb
	verb = 'seven'
	num = 7
;

eightVerb: choiceVerb
	verb = 'eight'
	num = 8
;

nineVerb: choiceVerb
	verb = 'nine'
	num = 9
;

//
// Here's where the user can quit.
//
quitVerb: object
	verb = '' 'q'
	action( actor ) = {
		local yn;
		"\b   ? (YES or NO) > ";
		yn := yorn();
		"\b";
		if ( yn = 1 ) {
			endgame.desc;
			quit();
		} else {
			"Okay. ";
		}
	}
;

//
// Here's where the user can back up one turn
//
undoVerb: object
	verb = '' 'u'
	action( actor ) = {
		if ( undo() && undo() ) {
			"(  .)\b\t";
			Me.location.desc;
		} else {
			"    .\b";
		}
	}
;

//
// This command is a concession to convention.
//
lookVerb: object
	verb = 'l' '' '' '' ''
	action( actor ) = {
		"\t";
		Me.location.desc;
	}
;

//
// Some very basic help
//
helpVerb: object
	verb = ''
	action( actor ) = {
		"       .
		       .
		          :\n
		\t\t  .\n
		\t\t .\n
		\t\t    (: '').\n
		\t\t   (: '').\n
		\t\t  .\n
		\t\t   .\n
		\t\t    .\n";
	}
;

//
// Save code paraphrased from adv.t
//
saveVerb: object
	verb = ''
	action( actor ) = {
		local savefile;

		savefile := askfile( '   ' );
		if ( savefile = nil or savefile = '' ) {
			". ";
		} else if ( save( savefile ) ) {
			". ";
		} else {
			". ";
		}
	}
;


//
// restore code paraphrased from adv.t
//
restoreVerb: object
	verb = '' ''
	action( actor ) = {
		local savefile;

		savefile := askfile( '  :' );
		if ( savefile = nil or savefile = '' ) {
			". ";
		} else if ( restore( savefile ) ) {
			"  . ";
		} else {
			".\b\t";
			Me.location.desc;
		}
	}
;

//
// restart code paraphrased from adv.t
//
initRestart: function( param )
{
	global.restarting := true;
}

restartVerb: object
	verb = ''
	action( actor ) = {
		local yesno;
		while ( true ) {
			"     ? (YES or NO) > ";
			yesno := yorn();
			if ( yesno = 1 ) {
				"\b\b* * *  * * *\b\b";
				restart(initRestart, global.initRestartParam);
				break;
			} else if ( yesno = 0 ) {
				"\nOkay.\n";
				break;
			}
		}
	}
;
